LUA_FUNCTION(GetCallback)
{
	if (Steam_BGetCallback(hSteamPipe, &CallbackMsg, &hSteamCall))
	{
		if (CallbackMsg.m_iCallback == GameOverlayActivated_t::k_iCallback)
		{
			GameOverlayActivated_t *gameOverlay = (GameOverlayActivated_t*)CallbackMsg.m_pubParam;

			gLua->Push(gLua->GetGlobal("hook")->GetMember("Call"));
			gLua->Push("SteamworksGameOverlayToggled");
			gLua->PushNil();
			gLua->Push((bool)gameOverlay->m_bActive);

			gLua->Call(3, 0);
		}
		else if (CallbackMsg.m_iCallback == PersonaStateChange_t::k_iCallback)
		{
			PersonaStateChange_t *personaChange = (PersonaStateChange_t *)CallbackMsg.m_pubParam;
				
			// build a string of flags
			std::string flags;
			for (int x = 1; x < 0x400; x *= 2)
			{
				if (personaChange->m_nChangeFlags & (EPersonaChange)x)
				{
					flags += EnumString<EPersonaChange>::From((EPersonaChange)x);
					flags += " ";
				}
			}

			CSteamID *steam = new CSteamID(personaChange->m_ulSteamID);
			
			gLua->Push(gLua->GetGlobal("hook")->GetMember("Call"));

			if (personaChange->m_nChangeFlags & EPersonaChange::k_EPersonaChangeName)
				gLua->Push("SteamworksFriendNameChanged");
			else if (personaChange->m_nChangeFlags & EPersonaChange::k_EPersonaChangeRelationshipChanged)
				gLua->Push("SteamworksFriendRelationshipChanged");
			else if (personaChange->m_nChangeFlags & EPersonaChange::k_EPersonaChangeAvatar)
				gLua->Push("SteamworksFriendAvatarChanged");
			else if (personaChange->m_nChangeFlags & EPersonaChange::k_EPersonaChangeStatus)
				gLua->Push("SteamworksFriendStatusChanged");
			else if (personaChange->m_nChangeFlags & EPersonaChange::k_EPersonaChangeGamePlayed)
			{
				uint64 gameId;
				uint32 gameIp;
				uint16 gamePort;
				uint16 queryPort;

				if (steamFriends02->GetFriendGamePlayed(*steam, &gameId, &gameIp, &gamePort, &queryPort))
					gLua->Push("SteamworksFriendGameLaunched");
				else		
					gLua->Push("SteamworksFriendGameClosed");
			}
			else if (personaChange->m_nChangeFlags & EPersonaChange::k_EPersonaChangeGameServer)
				gLua->Push("SteamworksFriendServerStatusChanged");

			gLua->PushNil();
			gLua->PushUserData(gLua->GetMetaTable(CSTEAMID_NAME, CSTEAMID_ID), steam);
						
			gLua->Call(3, 0);
		}
		Steam_FreeLastCallback( hSteamPipe );
	}

	return 0;
}