LUA_FUNCTION(AccountUniverse)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->Push(EnumString<EUniverse>::From(cID->GetEUniverse()).c_str());
	
	return 1;
}

LUA_FUNCTION(AccountInstance)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->PushDouble(cID->GetUnAccountInstance());
	
	return 1;
}

LUA_FUNCTION(AccountID)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->PushDouble(cID->GetAccountID());
	
	return 1;
}

LUA_FUNCTION(AccountID64)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->PushDouble(cID->ConvertToUint64());
	
	return 1;
}

LUA_FUNCTION(AccountType)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);
	
	gLua->Push(EnumString<EAccountType>::From(cID->GetEAccountType()).c_str());

	return 1;
}

LUA_FUNCTION(AccountStatus)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->Push(EnumString<EPersonaState>::From(steamFriends05->GetFriendPersonaState(*cID)).c_str());

	return 1;
}

LUA_FUNCTION(FriendRelationship)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->Push(EnumString<EFriendRelationship>::From(steamFriends05->GetFriendRelationship(*cID)).c_str());

	return 1;
}

LUA_FUNCTION(FriendName)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->Push(steamFriends05->GetFriendPersonaName(*cID));

	return 1;
}

LUA_FUNCTION(FriendNameHistory)
{
	gLua->CheckType(1, CSTEAMID_ID);
	gLua->CheckType(2, GLua::TYPE_NUMBER);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->Push(steamFriends05->GetFriendPersonaNameHistory(*cID, gLua->GetInteger(2)));
	
	return 1;
}

LUA_FUNCTION(GroupName)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->Push(steamFriends05->GetClanName(*cID));

	return 1;
}	

LUA_FUNCTION(GroupMemberCount)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->PushDouble(steamFriends05->GetFriendCountFromSource(*cID));
	
	return 1;
}

LUA_FUNCTION(GroupMemberByIndex)
{
	gLua->CheckType(1, CSTEAMID_ID);
	gLua->CheckType(2, GLua::TYPE_NUMBER);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);
	CSteamID *gID = new CSteamID(steamFriends05->GetFriendFromSourceByIndex(*cID, gLua->GetInteger(2)));

	if (gID->IsValid())
		gLua->PushUserData(gLua->GetMetaTable(CSTEAMID_NAME, CSTEAMID_ID), gID);
	else
		gLua->PushNil();

	return 1;
}

/*LUA_FUNCTION(SetIgnoreState)
{
	gLua->CheckType(1, CSTEAMID_ID);
	gLua->CheckType(2, GLua::TYPE_BOOL);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	clientFriends->SetIgnoreFriend(*cID, gLua->GetBool(2));

	return 0;
}*/

LUA_FUNCTION(SendMessage)
{
	gLua->CheckType(1, CSTEAMID_ID);
	gLua->CheckType(2, GLua::TYPE_STRING);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);
	
	EChatEntryType mType;

	if (gLua->GetString(3))
	{
		std::string strType(gLua->GetString(3));

		EnumString<EChatEntryType>::To(mType, strType);
	}
	else
		mType = EChatEntryType::k_EChatEntryTypeChatMsg;

	steamFriends02->SendMsgToFriend(*cID, mType, gLua->GetString(2), gLua->StringLength(2)+1);

	return 0;
}

LUA_FUNCTION(AddFriend)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	steamFriends02->AddFriend(*cID);

	return 0;
}

LUA_FUNCTION(RemoveFriend)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	steamFriends02->RemoveFriend(*cID);
	
	return 0;
}

LUA_FUNCTION(InviteToGroup)
{
	gLua->CheckType(1, CSTEAMID_ID);
	gLua->CheckType(2, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);
	CSteamID *gID = (CSteamID*)gLua->GetUserData(2);

	steamFriends02->InviteFriendToClan(*cID, *gID);

	return 0;
}

LUA_FUNCTION(IsInGroup)
{
	gLua->CheckType(1, CSTEAMID_ID);
	gLua->CheckType(2, CSTEAMID_ID);

	CSteamID *uID = (CSteamID*)gLua->GetUserData(1);
	CSteamID *gID = (CSteamID*)gLua->GetUserData(2);

	gLua->Push(steamFriends05->IsUserInSource(*uID, *gID));

	return 1;
}

LUA_FUNCTION(IsFriend)
{
	gLua->CheckType(1, CSTEAMID_ID);
	gLua->CheckType(2, GLua::TYPE_NUMBER);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	gLua->Push(steamFriends05->HasFriend(*cID, gLua->GetInteger(2)));

	return 1;
}

LUA_FUNCTION(__eq)
{
	gLua->CheckType(1, CSTEAMID_ID);
	gLua->CheckType(2, CSTEAMID_ID);

	CSteamID *cID1 = (CSteamID*)gLua->GetUserData(1);
	CSteamID *cID2 = (CSteamID*)gLua->GetUserData(2);

	if (*cID1 == *cID2)
		gLua->Push(true);
	else
		gLua->Push(false);

	return 1;
}