LUA_FUNCTION(AppInfo)
{
	gLua->CheckType(1, GAMEINFO_ID);

	GameInfoStruct *sInf = (GameInfoStruct*)gLua->GetUserData(1);

	gLua->PushUserData(gLua->GetMetaTable(APPINFO_NAME, APPINFO_ID), sInf->id);

	return 1;
}

LUA_FUNCTION(ServerIP)
{
	gLua->CheckType(1, GAMEINFO_ID);

	GameInfoStruct *sInf = (GameInfoStruct*)gLua->GetUserData(1);

	gLua->Push(sInf->ip.c_str());

	return 1;
}

LUA_FUNCTION(ServerPort)
{
	gLua->CheckType(1, GAMEINFO_ID);

	GameInfoStruct *sInf = (GameInfoStruct*)gLua->GetUserData(1);

	gLua->PushDouble(sInf->port);

	return 1;
}

LUA_FUNCTION(QueryPort)
{
	gLua->CheckType(1, GAMEINFO_ID);

	GameInfoStruct *sInf = (GameInfoStruct*)gLua->GetUserData(1);

	gLua->PushDouble(sInf->qport);

	return 1;
}

LUA_FUNCTION(GameInfo)
{
	gLua->CheckType(1, CSTEAMID_ID);

	CSteamID *cID = (CSteamID*)gLua->GetUserData(1);

	uint64 gameId;
	uint32 gameIp;
	uint8 *ipOctect = (uint8 *)&gameIp;
	uint16 gamePort;
	uint16 queryPort;

	steamFriends02->GetFriendGamePlayed(*cID, &gameId, &gameIp, &gamePort, &queryPort);

	std::stringstream conIP;
					
	for (int i=3;i>=0;i--)
	{
		conIP << (int)ipOctect[i];

		if (i != 0)
			conIP << ".";
	}

	CGameID *cGameId = new CGameID(gameId);
	GameInfoStruct *sInf = new GameInfoStruct;
	
	sInf->id = cGameId;
	sInf->ip = conIP.str().c_str();
	sInf->port = gamePort;
	sInf->qport = queryPort;

	gLua->PushUserData(gLua->GetMetaTable(GAMEINFO_NAME, GAMEINFO_ID), sInf);

	return 1;
}