#include <GMLuaModule.h>
#include <sstream>
#include <SteamAPI.h>
//#include <IClientEngine.h>
#include <IClientFriends.h>

#include "stdafx.h"
#include "callback.h"
#include "appinfo.h"
#include "gameinfo.h"
#include "csteamidfuncs.h"
#include "localfuncs.h"

int Load(lua_State *L)
{
	gLua = Lua();
	
	CreateInterfaceFn steamClientInterface = Sys_GetFactory("steamclient.dll");
	
	steamClient = (ISteamClient007*)steamClientInterface(STEAMCLIENT_INTERFACE_VERSION_007, NULL);

	if (!steamClient)
		gLua->Error("Unable to get ISteamClient.\n");

	/*clientEngine = (IClientEngine*)steamClientInterface(CLIENTENGINE_INTERFACE_VERSION, NULL);
	
	if (!clientEngine)
		gLua->Error("Unable to get IClientEngine.\n");*/

	if ((hSteamPipe = steamClient->CreateSteamPipe()) == NULL)
		gLua->Error("Unable to connect to steam instance.\n");

	if ((hSteamUser = steamClient->ConnectToGlobalUser(hSteamPipe)) == NULL)
		gLua->Error("Unable to connect to global user, please ensure you are logged into steam.\n");

	steamUser = (ISteamUser012*)steamClient->GetISteamUser(hSteamUser, hSteamPipe, STEAMUSER_INTERFACE_VERSION_012);

	if(!steamUser->LoggedOn())
		gLua->Error("The current user is offline.\n");

	steamFriends02 = (ISteamFriends002*)steamClient->GetISteamFriends(hSteamUser, hSteamPipe, STEAMFRIENDS_INTERFACE_VERSION_002);
	steamFriends05 = (ISteamFriends005*)steamClient->GetISteamFriends(hSteamUser, hSteamPipe, STEAMFRIENDS_INTERFACE_VERSION_005);
	//clientFriends = (IClientFriends*)clientEngine->GetIClientFriends(hSteamUser, hSteamPipe, CLIENTFRIENDS_INTERFACE_VERSION);

	ILuaObject *mTableA = gLua->GetMetaTable(APPINFO_NAME, APPINFO_ID);
		ILuaObject *__indexA = gLua->GetNewTable();
			__indexA->SetMember("AppID", AppID);
			__indexA->SetMember("ModID", ModID);

			__indexA->SetMember("IsValid", IsValid);
			__indexA->SetMember("IsMod", IsMod);
			__indexA->SetMember("IsSteamApp", IsSteamApp);
			__indexA->SetMember("IsP2PFile", IsP2PFile);
			__indexA->SetMember("IsShortcut", IsShortcut);

			mTableA->SetMember("__index", __indexA);
		__indexA->UnReference();
	mTableA->UnReference();

	ILuaObject *mTableG = gLua->GetMetaTable(GAMEINFO_NAME, GAMEINFO_ID);
		ILuaObject *__indexG = gLua->GetNewTable();
			__indexG->SetMember("AppInfo", AppInfo);

			__indexG->SetMember("ServerIP", ServerIP);
			__indexG->SetMember("ServerPort", ServerPort);

			__indexG->SetMember("QueryPort", QueryPort);

			mTableG->SetMember("__index", __indexG);
		__indexG->UnReference();
	mTableG->UnReference();

	ILuaObject *mTable = gLua->GetMetaTable(CSTEAMID_NAME, CSTEAMID_ID);
		ILuaObject *__index = gLua->GetNewTable();
			__index->SetMember("GameInfo", GameInfo);

			__index->SetMember("AccountUniverse", AccountUniverse);
			__index->SetMember("AccountInstance", AccountInstance);
			__index->SetMember("AccountID", AccountID);	
			__index->SetMember("AccountID64", AccountID64);
			__index->SetMember("AccountType", AccountType);
			__index->SetMember("AccountStatus", AccountStatus);

			__index->SetMember("FriendRelationship", FriendRelationship);
			__index->SetMember("FriendName", FriendName);
			__index->SetMember("FriendNameHistory", FriendNameHistory);

			__index->SetMember("GroupName", GroupName);
			__index->SetMember("GroupMemberCount", GroupMemberCount);
			__index->SetMember("GroupMemberByIndex", GroupMemberByIndex);

			//__index->SetMember("SetIgnoreState", SetIgnoreState);
			__index->SetMember("SendMessage", SendMessage);
			__index->SetMember("AddFriend", AddFriend);
			__index->SetMember("RemoveFriend", RemoveFriend);
			__index->SetMember("InviteToGroup", InviteToGroup);
			
			__index->SetMember("IsInGroup", IsInGroup);
			__index->SetMember("IsFriend", IsFriend);

			mTable->SetMember("__index", __index);
			mTable->SetMember("__eq", __eq);
		__index->UnReference();
	mTable->UnReference();

	gLua->NewGlobalTable("steamworks");

	ILuaObject *steamT = gLua->GetGlobal("steamworks");
		//steamT->SetMember("CreateCSteamID", CreateCSteamID);
		steamT->SetMember("LocalCSteamID", LocalCSteamID);

		steamT->SetMember("FriendCount", FriendCount);
		steamT->SetMember("FriendByIndex", FriendByIndex);

		steamT->SetMember("GroupCount", GroupCount);
		steamT->SetMember("GroupByIndex", GroupByIndex);
		
		steamT->SetMember("ActivateGameOverlay", ActivateGameOverlay);
		steamT->SetMember("AddFriendByName", AddFriendByName);

		steamT->SetMember("SetName", SetName);
		steamT->SetMember("GetName", GetName);

		steamT->SetMember("SetStatus", SetStatus);
		steamT->SetMember("GetStatus", GetStatus);
	steamT->UnReference();

	gLua->Push(gLua->GetGlobal("hook")->GetMember("Add"));
	gLua->Push("Think");
	gLua->Push("SteamworksListenForEvents");
	gLua->Push(GetCallback);

	gLua->Call(3, 0);

	return 0;
}

int Unload(lua_State *L)
{	
	return 0;
}